<?php
/* Photopress uploader - original hack by shockingbird.com for b2 */

require_once( dirname(dirname(dirname(dirname(__FILE__)))) . '/wp-config.php');
require_once( ABSPATH . 'wp-content/plugins/photopress/include.php');

get_currentuserinfo();
if ($user_level == 0) //Checks to see if user has logged in
        die (__('Try logging in','photopress'));
if ($user_level < $pp_options['min_level']) //Checks to see if user's level is high enough
        die (__('Ask the administrator to promote you.'));

// print the header (there's probably a better way to do this)
echo '
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>WordPress &rsaquo; Upload Images</title>
<link rel="stylesheet" href="' . get_settings('siteurl') . '/wp-admin/wp-admin.css" type="text/css" />
<link rel="shortcut icon" href="' . get_settings('siteurl') . '/wp-images/wp-favicon.png" />
<meta http-equiv="Content-Type" content="text/html; charset=' . get_settings('blog_charset') . '" />
<script type="text/javascript">
<!-- // idocs.com popup tutorial rules !
function insertcode(blah1, blah2, blah3) {
   var linkcode;
	linkcode = "[photopress:" + blah1 + "," + blah2 + "," + blah3 + "] \n";
	if (! (window.focus && window.opener))return true;
	window.opener.focus();
	window.opener.document.post.content.value += linkcode;
	return false;
}
function setnumphotos(num) {
	window.top.location.href = "' . get_settings('siteurl') . '/wp-content/plugins/photopress/popup.php?action=upload&num_photos=" + num.options[num.selectedIndex].value;
	return false;
}
function setbrowsesort(sort) {
	window.top.location.href = "' . get_settings('siteurl') . '/wp-content/plugins/photopress/popup.php?action=browse&sort=" + sort.options[sort.selectedIndex].value;
	return false;
}
//-->
</script>
</head>
<body>
<ul id="adminmenu">
	<li><a '; if ($_GET['action'] == 'upload' || $_POST['upload']) { echo 'class="current" ';} echo 'href="' . get_settings('siteurl') . '/wp-content/plugins/photopress/popup.php?action=upload">' . __('Upload','photopress') . '</a></li>
	<li><a ';  if ($_GET['action'] == 'browse') { echo 'class="current" ';} echo 'href="' . get_settings('siteurl') . '/wp-content/plugins/photopress/popup.php?action=browse">' . __('Browse','photopress') . '</a></li>
	<li><a href="#" onclick="window.close()">' . __('Close window','photopress') . '</a></li>
</ul>
<div class="wrap">
';

if ($_GET['action'] == 'browse') {
	echo '<h3>' . __('Browsing Images','photopress') . '</h3>
	';
	$image_count = pp_count();
	if ($image_count > 0) {
		if ($image_count > 1) {
			echo '<p><form>' . __('Sort: ','photopress') . '<select name="sort" onChange="setbrowsesort(this)">
				<option value="imgtimeD"'; if ($_GET['sort'] == 'imgtimeD' || !isset($_GET['sort'])) { echo ' selected="selected"'; } echo '>' . __('New to Old','photopress') . '</option>
				<option value="imgtimeA"'; if ($_GET['sort'] == 'imgtimeA') { echo ' selected="selected"'; } echo '>' . __('Old to New','photopress') . '</option>
				<option value="imgfileA"'; if ($_GET['sort'] == 'imgfileA') { echo ' selected="selected"'; } echo '>' . __('A to Z','photopress') . '</option>
				<option value="imgfileD"'; if ($_GET['sort'] == 'imgfileD') { echo ' selected="selected"'; } echo '>' . __('Z to A','photopress') . '</option>
			</select></form></p>';
		}
		if ($_GET['sort'] == 'imgfileD') {
			$pp_sort = 'imgfile DESC';
		} elseif ($_GET['sort'] == 'imgfileA') {
			$pp_sort = 'imgfile';
		} elseif ($_GET['sort'] == 'imgtimeA') {
			$pp_sort = 'imgtime';
		} else {
			$pp_sort = 'imgtime DESC';
		}
		if ($image_count > 0) {
			$pages = (int)ceil($image_count/$pp_options['images_per_page']);
			if ($pages > 1) {
			if (isset($_GET['page'])) {
				$current_page = $_GET['page'];
			} else {
				$current_page = 1;
			}
			echo '<p>';
			if ($current_page > 1) {
				echo '<a href="' . get_settings('siteurl') . '/wp-content/plugins/photopress/popup.php?action=browse&amp;page=' . ($current_page - 1) . '">';
			}
			echo __('Previous','photopress') . ' | ';
			if ($current_page > 1) {
				echo '</a>';
			}
			for ($i = 1; $i <= $pages; $i++) {
				if ($i != $current_page) {
					echo '<a href="' . get_settings('siteurl') . '/wp-content/plugins/photopress/popup.php?action=browse&amp;page=' . $i . '">';
				}
				echo $i;
				if ($i != $current_page) {
					echo '</a>';
				}
				if ($i < $pages) {
					echo ' | ';
				}
			}
			if ($current_page < $pages) {
				echo '<a href="' . get_settings('siteurl') . '/wp-content/plugins/photopress/popup.php?action=browse&amp;page=' . ($current_page + 1) . '">';
			}
			echo ' | ' . __('Next','photopress');
			if ($current_page < $pages) {
				echo '</a>';
			}
			$list_start = ($current_page - 1) * $pp_options['images_per_page'];
			echo '</p>';
			} else { // there's only one page so we'll start with the 0th image
				$list_start = 0;
			}
			echo '<form name="photopress" method="post">
			<table>';
			$current_image_list = pp_images_with_data(FALSE,$pp_sort,$list_start,$pp_options['images_per_page']);
			foreach ((array)$current_image_list as $image) {
				$thumbsize = getimagesize($pp_options['photospath'] . '/' . $pp_options['thumbprefix'] . $image['imgfile']);
				echo '<tr><td><img src="' . $pp_options['photosaddress'] . '/' . $pp_options['thumbprefix'] . $image['imgfile'] . '" ' . $thumbsize . ' title="' . stripslashes($image['imgname']) . '" /></td>
				<td><form>
				<input type="hidden" name="file" value="' . $image['imgfile'] . '" />
				<select name="thumb">
					<option value="thumb"'; if ($pp_options['insert_thumb'] == '1') { echo ' selected="selected"'; } echo '>' . __('Thumbnail','photopress') . '</option>
					<option value="full"'; if ($pp_options['insert_thumb'] == '0') { echo ' selected="selected"'; } echo '>' . __('Full Image','photopress') . '</option>
				</select><br />
            <select name="classes">';
				$classes = explode(' ',trim($pp_options['image_class']));
				foreach ((array)$classes as $class) {
					echo '<option value="' . $class . '"'; if ($class == $classes[0]) { echo ' selected="selected"'; } echo '>' . $class . '</option>
					';
				}
				if (strlen($image['imgfile']) > 20) {
					$image_file_short = substr($image['imgfile'],0,17) . '...';
				} else {
					$image_file_short = $image['imgfile'];
				}
				echo '</select><br />
				<input type="button" name="insert" value="' . __('Insert','photopress') . ' ' . $image_file_short . '" onClick="insertcode(this.form.file.value,this.form.thumb.options[this.form.thumb.selectedIndex].value,this.form.classes.options[this.form.classes.selectedIndex].value)" />
				</form></td></tr>
				';
			}
			echo '</table>
			</form>';
		}
	} else {
		echo '<p>' . __('No images uploaded yet.','photopress') . '</p>';
	}
	echo '
	</div>
</body>
</html>';
die();
}

if ($_GET['action'] == 'upload') {
	if (!is_writable($pp_options['photospath'])) {
		echo '<h3>' . __('Photos folder is not Writable','photopress') . '</h3>
		<p>';
		printf(__("It doesn't look like you can use Photopress at this time because the directory you have specified (<code>%s</code>) isn't writable. Check the permissions on the directory and for typos in your configuration.","photopress"), $pp_options['photospath']);
		echo '</p>
		</div>
		</body>
		</html>';
		die();
	}
	if (isset($_GET['num_photos'])) {
		$num_photos = $_GET['num_photos'];
	} else {
		$num_photos = 1;
	}
	echo '<h3>' . __('Uploading Images','photopress') . '</h3>
		<p>' . __('Number to upload:','photopress') . '<select name="num_photos" onChange="setnumphotos(this)">';
		for ($i=1;$i<=10;$i++) {
			echo '<option value="' . $i . '" ';
				if ((int)$num_photos == $i) {
					echo 'selected="selected"';
				}
			echo '>' . $i . '</option>
			';
		}
		echo '</select></p>
		<form action="' . get_settings('siteurl') . '/wp-content/plugins/photopress/popup.php" method="post" enctype="multipart/form-data">
		<input type="hidden" name="upload" id="upload" value="yes" />';
		for ($i=0; $i<$num_photos; $i++) {
			echo '<p><input type="file" name="file_name[]" id="file_name" size="30" class="uploadform" /></p>
			';
		}
		echo '<p class="submit"><input type="submit" name="submit" value="' . __('Upload','photopress') . '" /></p>
		</form>
	</div>
</body>
</html>';
die();
}

if ($_POST['submit']) {
	if ($_POST['upload']) {
		echo '<h3>' . __('Images Uploaded','photopress') . '</h3>
		<p>' . __('Your images were uploaded, and renamed if necessary. You can enter some information about these images now or just save the defaults and move on to the next screen, where you can insert the images into your post.','photopress') . '</p>
		<form action="' . get_settings('siteurl') . '/wp-content/plugins/photopress/popup.php" method="post" enctype="multipart/form-data">
		<input type="hidden" name="data_update" value="update" />
		<table>
		';
		$allowedtypes = explode(' ', trim(strtolower($pp_options['allowedtypes'])));
		$j=0;
		foreach ($_FILES['file_name']['error'] as $key=>$error) {
			$type = trim(strtolower(pathinfo($_FILES['file_name']['name'][$key],PATHINFO_EXTENSION)));
			$mime = explode('/',$_FILES['file_name']['type'][$key]);
			if (in_array($type,$allowedtypes) && in_array(strtolower($mime[1]),$allowedtypes)) { // both the extension and the mime type are allowed
				$clean_name = preg_replace('/[^a-z0-9_.]/i', '_', $_FILES['file_name']['name'][$key]);
				$destination = $pp_options['photospath'] . '/' . $clean_name;
				$i=1;
				while (is_file($destination)) { // if it's a dupe give it a new name
					$image_name = pathinfo($_FILES['file_name']['name'][$key],PATHINFO_BASENAME);
					$realbase = substr($image_name,0,strrpos($image_name, '.'));
					$destination = $pp_options['photospath'] . '/' . $realbase . '_' . $i . '.' . pathinfo($_FILES['file_name']['name'][$key],PATHINFO_EXTENSION);
					$i++;
				}
				move_uploaded_file($_FILES['file_name']['tmp_name'][$key],$destination);
				$resized = pp_resize($destination, $pp_options['maxsize'], 0, '');
				@chmod($destination,0664);
				$thumbed = pp_resize($destination, $pp_options['thumbsize'], $pp_options['thumbsize'], $pp_options['thumbprefix']);
				$imgfile = pathinfo($destination,PATHINFO_BASENAME);
				@chmod($pp_options['photospath'] . '/' . $pp_options['thumbprefix'] . $imgfile,0664);
				$imgname = strtr(substr($imgfile,0,strrpos($imgfile, '.')),'_',' ');
				$update_array = array($imgfile,$imgname,$imgname,'Default');
				$updated = pp_table_update($update_array);
				$thumbsize = getimagesize($pp_options['photospath'] . '/' . $pp_options['thumbprefix'] . $imgfile);
				echo '<tr>
				<td><img src="' . $pp_options['photosaddress'] . '/' . $pp_options['thumbprefix'] . $imgfile . '" ' . $thumbsize[3] . ' /></td>
				<td><input type="hidden" name="row' . $j . '[imgfile]" value="' . $imgfile . '" />'. __('Filename: ','photopress') . $imgfile . '<br />
				' . __('Name: ','photopress') . '<input type="text" name="row' . $j . '[imgname]" class="uploadform" size="20" value="' . $imgname . '" /><br />
				' . __('Description: ','photopress') . '<input type="text" name="row' . $j . '[imgdesc]" class="uploadform" size="20" value="' . $imgname . '" /><br />
				' . __('Category: ','photopress') . '<input type="text" name="row' . $j . '[imgcat]" class="uploadform" size="20" value="" /><br />';
				$pp_categories = pp_list_cats();
				echo '<select name="row' . $j . '[imgcatdrop]">';
				echo pp_cat_dropdown($pp_categories);
				echo '</select><br />
				</td></tr>';
				$j++;
			}
		}
		echo '</table>
		';
		echo '<p class="submit"><input type="submit" name="submit" value="' . __('Next','photopress') . '" /></p>
		</form>
		<div>
</body>
</html>';
die();
	} elseif (isset($_POST['data_update'])) {
		echo '<h3>' . __('Insert Images','photopress') . '</h3>
		<form>
		<table>';
		foreach ((array)$_POST as $key=>$data_update) {
			if (is_array($data_update)) {
				if (!empty($data_update['imgcat'])) {
					$imgcat = $data_update['imgcat'];
				} else {
					$imgcat = $data_update['imgcatdrop'];
				}
				$update_array = array($data_update['imgfile'],$data_update['imgname'],$data_update['imgdesc'],$imgcat);
				pp_table_update($update_array);
				$image_link_code = '[photopress:'. $data_update['imgfile'] . ',full]';
				$thumb_link_code = '[photopress:' . $data_update['imgfile'] . ',thumb]';
				$thumbsize = getimagesize($pp_options['photospath'] . '/' . $pp_options['thumbprefix'] . $data_update['imgfile']);
				echo '<tr><td><img src="' . $pp_options['photosaddress'] . '/' . $pp_options['thumbprefix'] . $data_update['imgfile'] . '" ' . $thumbsize . ' title="' . stripslashes($data_update['imgname']) . '" /></td>
				<td><form>
				<input type="hidden" name="file" value="' . $data_update['imgfile'] . '" />
				<select name="thumb">
					<option value="thumb"'; if ($pp_options['insert_thumb'] == '1') { echo ' selected="selected"'; } echo '>' . __('Thumbnail','photopress') . '</option>
					<option value="full"'; if ($pp_options['insert_thumb'] == '0') { echo ' selected="selected"'; } echo '>' . __('Full Image','photopress') . '</option>
				</select><br />
            <select name="classes">';
				$classes = explode(' ',trim($pp_options['image_class']));
				foreach ((array)$classes as $class) {
					echo '<option value="' . $class . '"'; if ($class == $classes[0]) { echo ' selected="selected"'; } echo '>' . $class . '</option>
					';
				}
				if (strlen($data_update['imgfile']) > 20) {
					$image_file_short = substr($data_update['imgfile'],0,17) . '...';
				} else {
					$image_file_short = $data_update['imgfile'];
				}
				echo '</select><br />
				<input type="button" name="insert" value="' . __('Insert','photopress') . ' ' . $image_file_short . '" onClick="insertcode(this.form.file.value,this.form.thumb.options[this.form.thumb.selectedIndex].value,this.form.classes.options[this.form.classes.selectedIndex].value)" />
				</form></td></tr>
				';
			}
		}
		echo '</table>
		<p class="submit"><input type="button" value="' . __('Close','photopress') . '" onclick="window.close()" /></p>
		</form>
	<div>
</body>
</html>';
die();
	}
}
?>
